# 自定义样式

> 通过 `wrapClassName` 配合 `css` 自定义 `dialog` 样式

## className

<div id="demo"></div>

````js
var React = require('react')
var ReactDOM = require('react-dom')
var Dialog = require('react-fast-dialog')
var App = React.createClass({
    getInitialState: function () {
        return {
            show: false
        }
    },
    onClose: function () {
        this.setState({
            show: false
        })
    },
    showDialog: function () {
        this.setState({
            show: true
        })
    },
    render: function () {
        return (
            <div>
                <button type="button" onClick={this.showDialog} >wrapClassName</button>
                <Dialog
                    wrapClassName="my-dialog--night"
                    title={'wrapClassName'}
                    onClose={this.onClose}
                    show={this.state.show}
                 >
                    wrapClassName
                </Dialog>
            </div>
        )
    }
})
ReactDOM.render(<App />, document.getElementById('demo'))
````

````css
/* 通过增加 wrap class name 的方式用 css 自定义dialog样式 */
.my-dialog--night {
    z-index: 1010;
}

.my-dialog--night .rf-dialogMask {
    background-color:black;
    opacity: .7;
}
/* 蓝色边框 黑色背景 白色文字 */
.my-dialog--night .rf-dialog {
    border:1px solid #ABCDEF;
    background-color:#555;
    color:white;
}
.my-dialog--night .rf-dialog-hd {
    border-bottom:1px solid #ABCDEF;
    position: relative;
    line-height: 2em;
    padding-left: .5em;
    padding-right: 2.2em;
}
.my-dialog--night .rf-dialog-hd-title {

}
.my-dialog--night .rf-dialog-hd-close {
    display: block;
    cursor: pointer;
    border: 0;
    background: transparent;
    font-size: 1.5em;
    position: absolute;
    padding-left: .4em;
    padding-right: .4em;
    right: 0;
    top: 0;
    font-weight: 700;
    line-height: 1.4em;
    color: white;
    text-shadow: 0 1px 0 #000;
    filter: alpha(opacity=20);
    opacity: .2;
    text-decoration: none;
}
.my-dialog--night .rf-dialog-bd {
    padding:.5em;
}
````
