# 队列弹窗

## 共用同一个窗口

<div id="demo"></div>

````js
var React = require('react')
var ReactDOM = require('react-dom')
var Dialog = require('react-fast-dialog')

var App = React.createClass({
    getInitialState: function () {
        return {
            show: false,
            dialogQueue: []
        }
    },
    onClose: function () {
        var self = this
        var dialogQueue = self.state.dialogQueue
        dialogQueue.shift()
        self.setState({
            dialogQueue: dialogQueue
        })
    },    
    send: function () {
        var self = this
        // mock ajax
        setTimeout(function () {
            console.log('callback A')
            self.setState({
                dialogQueue: self.state.dialogQueue.concat('A ok')
            })
        }, Math.random()*2000)

        // mock ajax
        setTimeout(function () {
            console.log('callback B')
            self.setState({
                dialogQueue: self.state.dialogQueue.concat('B ok')
            })
        }, Math.random()*2000)
    },
    render: function () {
        return (
            <div>
                <button type="button" onClick={this.send} >Send AJAX</button>
                <Dialog title={'queue'} onClose={this.onClose} show={this.state.dialogQueue[0]} >
                    {this.state.dialogQueue[0]}
                </Dialog>
            </div>
        )
    }
})
ReactDOM.render(<App />, document.getElementById('demo'))
````
